<?php

	$servername = "localhost";
	$username = "";
	$password = "";
	$dbname = "";
	$file_nameG = "/home/PATH TO YOUR/.htaccess";
	$emailaddress = "";
	$site_name = ""


	//
	// Create connection
	//
	$conn = mysqli_connect($servername, $username, $password, $dbname);


	//
	// Check connection
	//
	if (!$conn) {
		die("Connection failed: " . mysqli_connect_error());
	} else {
	//	print_r( "Connected successfully<br>");
	}


	//
	// Check if a last retrieved has been set
	//
	$sql = "SELECT ip_address FROM custom_spam_tracker WHERE last_retrieved = 1";

	$result = mysqli_query($conn, $sql);

	if ($result->num_rows < 1) {

		print_r("Previous ip retrieval was not made.");

		//
		// If no last retrieved then retrieve all ips
		//
		$sql = "SELECT ip_address FROM custom_spam_tracker";

		$result = mysqli_query($conn, $sql);

		if ($result->num_rows < 1) {
			print_r("No new spam attempt.");
			exit;
		}

	} else {

		//
		// If last retrieved then retrieve ips from that point on
		//
		$sql = "SELECT ip_address FROM custom_spam_tracker WHERE date_time > (SELECT date_time FROM custom_spam_tracker WHERE last_retrieved = 1)";

		$result = mysqli_query($conn, $sql);

		if ($result->num_rows < 1) {
			print_r("No new spam attempt.");
			exit;
		}

	}


//	print_r($result);


	//
	// Read the content of the htaccess
	//
	$existingContent = file_get_contents($file_nameG);

	$ip_denials = "";

	while ($row = mysqli_fetch_assoc($result)) {

//		print_r("<pre>");
//		print_r($row['ip_address']);
//		print_r("</pre>");

		// Compile all ips into one variable
		$ip_denials .= "\ndeny from " . $row['ip_address'];
	}


//	print_r("<pre>");
//	print_r($ip_denials);
//	print_r("</pre>");


	//
	// Prepend the ip addresses
	//
	$updatedContent = $ip_denials . "\n" . $existingContent;


	//
	// Write the updated content back to the file
	//
	file_put_contents($file_nameG, $updatedContent);


/*

	$sql = "DELETE FROM custom_spam_tracker"; // Delete all records
	if ($conn->query($sql) === TRUE) {
		print_r("<pre>");
		print_r("All records deleted successfully.");
		print_r("</pre>");
	} else {
		print_r("<pre>");
		print_r("Error deleting records: " . $conn->error);
		print_r("</pre>");
	}

*/


	//
	// Update database table for next retrieval
	//
	$sql = "UPDATE custom_spam_tracker SET last_retrieved = NULL WHERE last_retrieved = '1'";
	$result = mysqli_query($conn, $sql);

	$sql = "UPDATE custom_spam_tracker SET last_retrieved = '1' WHERE date_time = (SELECT MAX(date_time) FROM custom_spam_tracker)";
	$result = mysqli_query($conn, $sql);

	$conn->close();


	//
	// Send email notification
	//
	$subject = 'Site IP auto block access';

	$message = $site_name . " site spam or forbidden access ip blocked: \n";
	$message = $ip_denials . "\n\n";
	$message .= "Time of ip block update: " . date('m-d-Y_H-i-s') . "\n\n";

	$headers = 'From: ' . $emailaddress . "\r\n" .
		'Reply-To: ' . $emailaddress . "\r\n" .
		'X-Mailer: PHP/' . phpversion();

	if (mail($emailaddress, $subject, $message, $headers)) {
		print_r("\n IP blocking completed successfully. Email sent to $emailaddress.");
	} else {
		print_r("\n IP blocking completed, but email notification failed.");
	}



?>